// JavaScript Document
	
		var stage;
		var queue;
		
		var iconIndex;
		var iconList = [];
		
		var exitIndex = 0;
		var exitList = [];
		var exitFired = false;
		var exitTweenIn = exitspecs.tweenin;

		var playerIndex = 0;
		var playerList = []; // container list for player
		var spinTune = playerspecs.spintune;
		var playerBmpList = []; // player bmp in container
		
		var playerAdvance = playerspecs.advance;
		var advanceTargetList = playerspecs.advancetargets; // ["icon", "icon-player", "player"]
		var advanceTargetIndex = -1;
		var indexOfIcon = advanceTargetList.indexOf("icon");
		var playerTimerCutOff = playerspecs.timercutoff;

		var offPlayerList = [];
		var offPlayerBmpList = [];
		var trackOffDisplay = false;

		var popIndex;
		var popList = [];
		var liveHitClass; // "icon" || "player" || "icon-player"
		var liveHitIndex;

		var dragMaxLeft = playerspecs.bounds[0]; // [x,y,width,hieght]
		var dragMaxTop = playerspecs.bounds[1]; // [x,y,width,hieght]
		var dragMaxRight = playerspecs.bounds[2]; // [x,y,width,hieght]
		var dragMaxBottom = playerspecs.bounds[3]; // [x,y,width,hieght]

		var dragCenterX = playerspecs.spincenter[0];
		var dragCenterY = playerspecs.spincenter[1];

		var inPlayPause = playerspecs.inplaypause;

		var hitRange = gamespecs.hitrange;
		var collisionClass = gamespecs.collision;

		var scoreIndex = 0;
		var scoreList = [];
		var scoreContainerList = [];
		var scoreMin = scorespecs.scoremin;
		var scoreMax = scorespecs.scoremax;
		var scoreClass = scorespecs.class; // "standard" || "class"

		var screenScoreShow = roundspecs.showscreenscore; // = true: show score during play || false = hide score during play 
		var exitScoreShow = roundspecs.showexitscore; // = true: show exit pop-up score || false = hide exit pop-up score;
		var showScoreList = [screenScoreShow, exitScoreShow];

		var timerIndex = 0;
		var timerList = [];
		var timerMax;
		var timeSource;
		var timerCount = 0;
		var trackTimer = false;
		var timerStarted = false;

		var directionList = [];
		var directionIndex = 0;
		var hasDirections = false;

		var hasRounds = false;	
		var roundsComplete = false;
		var roundMax = roundspecs.roundmax; // = number of rounds to play before end
		var lastRoundIndex = roundMax -1; // zero indexed of round max, number of rounds to play before end
		var roundScoreMaxList = roundspecs.scoremax; // = max score to close round
		var roundScoreMinList = roundspecs.scoremin; // = min score to close round
		var roundTimeList = roundspecs.times;  // = time to close round

		var roundWinList = [0,0,0,0,0,0,0,0,0,0,]; // 0=loss, 1=win
		var roundWinCount = 0; // final count of rounds win
		var roundWinClass = roundspecs.multiexit; // "rounds" for rounds win || "points" for game point total

		var roundTabIndex = 0;
		var roundTabList = [];
		var roundTabContainerList = [];

		var roundTabListX = roundtabspecs.x;
		var roundTabListY = roundtabspecs.y;

		var roundSparks = roundspecs.resetsparks;

		var roundIndex = 0;		
		var roundsPlayed = 0;
		var roundSuccess = true;
		var roundSuccessList = [];
		var roundReplay = roundspecs.roundreplay; // true:must replay if score not met || false: advance to next round
		var trackScoreList = [0,0,0,0,0,0,0,0,0,0,0,];
		var trackRoundsList = [0,0,0,0,0,0,0,0,0,0,0,];

		var playNextIndex = 0;
		var playNextTarget = -1;
		var playNextBmpList = [];
		var playNextContainerList = [];
		var playNextCount = playnextspecs.count;
		var trackPlayNext = false;

		var roundCountIndex = 0;
		var roundCountList = [];
		

// DIRECTIONS TWEEN IN ....		
	var drcTweenIn = directionspecs.tweenin;
	var drcPauseIn = directionspecs.pausein;
	var drcTimeIn = directionspecs.timein;
	var drcAlphaIn = directionspecs.alphain;
	var drcScaleInX = directionspecs.scalexin;
	var drcScaleInY = directionspecs.scaleyin;
	var drcSpinIn = directionspecs.spinin;
	var drcOffsetInX = directionspecs.xin;
	var drcOffsetInY = directionspecs.yin;
	var drcSparksIn = directionspecs.sparksin;

	// DIRECTIONS TWEEN OUT ....
	var drcTweenOut = directionspecs.tweenout
	var drcPauseOut = directionspecs.pauseout;
	var drcTimeOut = directionspecs.timeout;
	var drcAlphaOut = directionspecs.alphaout;
	var drcScaleOutX = directionspecs.scalexout;
	var drcScaleOutY = directionspecs.scaleyout;
	var drcSpinOut = directionspecs.spinout;
	var drcOffsetOutX = directionspecs.xout;
	var drcOffsetOutY = directionspecs.yout;
	var drcSparksOut = directionspecs.sparksout;

// PLAYER TWEEN IN ....		
	var playerTweenIn = playerspecs.tweenin;
	var playerPauseIn = playerspecs.pausein;
	var playerTimeIn = playerspecs.timein;
	var playerAlphaIn = playerspecs.alphain;
	var playerScaleInX = playerspecs.scalexin;
	var playerScaleInY = playerspecs.scaleyin;
	var playerSpinIn = playerspecs.spinin;
	var playerOffsetInX = playerspecs.xin;
	var playerOffsetInY = playerspecs.yin;
	var playerSparksIn = playerspecs.sparksin;

	// PLAYER TWEEN OUT ....
	var playerTweenOut = playerspecs.tweenout
	var playerPauseOut = playerspecs.pauseout;
	var playerTimeOut = playerspecs.timeout;
	var playerAlphaOut = playerspecs.alphaout;
	var playerScaleOutX = playerspecs.scalexout;
	var playerScaleOutY = playerspecs.scaleyout;
	var playerSpinOut = playerspecs.spinout;
	var playerOffsetOutX = playerspecs.xout;
	var playerOffsetOutY = playerspecs.yout;
	var playerSparksOut = playerspecs.sparksout;

// ICON TWEENS 
	var iconMotionStarted = false;	
	var iconInXlist = iconspecs.inx; // [320]
	var iconInYlist = iconspecs.iny; // [0]
	var iconOutXlist = iconspecs.outx; // [320]
	var iconOutYlist = iconspecs.outy; // [640]
	var iconExitClass = iconspecs.exitclass;  // "x", "y", "xy"
	var iconOffsetXIn = iconspecs.randominxy[0]; // [100,0] [xOffset,yOffset]
	var iconOffsetYIn = iconspecs.randominxy[1]; // [100,0] [xOffset,yOffset]
	var iconOffsetXOut = iconspecs.randomoutxy[0]; // [0,0] [xOffset,yOffset]
	var iconOffsetYOut= iconspecs.randomoutxy[1]; // [0,0] [xOffset,yOffset]
	var iconOffsetSpin = iconspecs.randomspin; // 180,
	var iconOffsetPause = iconspecs.randompause; // 500,
	var iconTween = iconspecs.tween; // createjs.Ease.sineOut
	var iconAlphaIn = iconspecs.alphain; // 0
	var iconScaleXin = iconspecs.scalexin; // 0
	var iconScaleYin = iconspecs.scaleyin; // 0
	var iconSpinIn = iconspecs.spinin; // 180
	var iconScaleOutX = iconspecs.scalexout; // 1.5
	var iconScaleOutY = iconspecs.scaleyout; // 1.5
	var iconActiveShow = iconspecs.activeshow;

var bkgList = [];
var bkgPickList = [];


// BKG ICON TWEENS 
var bkgInX = bkgspecs.inx;
var bkgInY = bkgspecs.iny;
var bkgOutX = bkgspecs.outx;
var bkgOutY = bkgspecs.outy;
var bkgAlphaIn = bkgspecs.alphain;
var bkgAlphaOut = bkgspecs.alphaout;
var bkgScaleIn = bkgspecs.scalein;
var bkgScaleOut = bkgspecs.scaleout;
var bkgSpin = bkgspecs.spin;
var bkgSpinOffset = bkgspecs.spinoffset;
var bkgTime = bkgspecs.time;
var bkgNextTime = bkgspecs.next;
var bkgTimeOffset = bkgspecs.timeoffset;
var bkgPause = bkgspecs.pause;
var bkgPauseOffset = bkgspecs.pauseoffset;
var bkgTween = bkgspecs.tween;
var bkgRandomAngles = bkgspecs.randomangles;
var bkgLoopForever = bkgspecs.forever;

/* :::::::::: [ MARKER VARS ] :::::::::: */
var killPositive = killspecs.killpositive; // killpositive:true, killnegative:true, killtarget:true,
var killNegative = killspecs.killnegative;
var killCeiling = killspecs.ceilingnegative;

/* :::::::::: [ MARKER VARS ] :::::::::: */
var markerIndex = 0;
var markerTargetScore = 0;
var markerBmpList = [];
var markerContainerList = [];
var markerCount = markerspecs.count;
var markerExitHide = markerspecs.hideonexit;
var markerHasRightWrong = markerspecs.rightwrong;
var markerNegativeFloor = markerspecs.negativefloor; // lowest score t show marker
var markerShowOnRound = markerspecs.showonround;
var trackMarker = false;

// MARKER TWEENS
var markerOffsetX = markerspecs.offsetx;
var markerOffsetY = markerspecs.offsety;
var markerScaleInX = markerspecs.scaleinx;
var markerScaleInY = markerspecs.scaleiny;
var markerInAlpha = markerspecs.inalpha;
var markerRotation = markerspecs.rotation;
var markerPause = markerspecs.pause;
var markerTime  = markerspecs.time;
var markerTween = markerspecs.tween;

// PLAY NEXT TWEENS 
var playNextTweenIn = playnextspecs.tweenin;
var playNextPauseIn = playnextspecs.pausein;
var playNextTimeIn = playnextspecs.timein;
var playNextAlphaIn = playnextspecs.alphain;
var playNextScaleInX = playnextspecs.scalexin;
var playNextScaleInY = playnextspecs.scaleyin;
var playNextSpinIn = playnextspecs.spinin;
var playNextInX = playnextspecs.xin;
var playNextInY = playnextspecs.yin;
var playNextSpaksIn = playnextspecs.sparksin;

var playNextTweenOut = playnextspecs.tweenout;
var playNextPauseOut = playnextspecs.pauseout;
var playNextTimeOut = playnextspecs.timeout;
var playNextAlphaOut = playnextspecs.alphaout;
var playNextScaleOutX = playnextspecs.scalexout;
var playNextScaleOutY = playnextspecs.scaleyout;
var playNextSpinOut = playnextspecs.spinout;
var playNextOutX = playnextspecs.xout;
var playNextOutY = playnextspecs.yout;
var playNextSparksOut = playnextspecs.sparksout;
		
		var skinIndex;
		var skinList = [];
		
		var upshotIndex;
		var upshotList = [];

		var autoGatewayList = [];
		var autoGateTimeList = [];
		var hasAutoGateway = false;
		var autoGateIndex = 0;
		
		var loadQueueLive = true;
		var linkTo = "replace"; // "replace", "location", "open", "banner-open"
		var linkWindow;
		var windowTools = "toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes";

var choiceList = [];
		
        function init() {
            //Create stage object - our root level container
            stage = new createjs.Stage("boomCanvas");
			
			addForm();
			addPreload(); // FUNC in form_styler.js
			setSpecs();
			
			//Create a load queue to handle preloading assets
            queue = new createjs.LoadQueue(loadQueueLive, imgpath, true);
            //queue.installPlugin(createjs.Sound);
            queue.addEventListener("complete", loadComplete);
			queue.setMaxConnections(10);
			queue.loadManifest(manifest);

        }
		
		function loadComplete(event) {
			
			for (i = 0; i < manifest.length; i++) {
				if(manifest[i].class == "motion"){
					addBkgMotion(i);
					addBkgMotion(i);
				};
				if(manifest[i].class == "pop"){addPop(i)};
				if(manifest[i].class == "icon"){addIcon(i)};
				if(manifest[i].class == "marker"){addMarker(i)};
				if(manifest[i].class == "offplayer"){addOffPlayer(i)};
				if(manifest[i].class == "player"){addPlayer(i)};
				if(manifest[i].class == "skin"){addSkin(i)};
				if(manifest[i].class == "exit"){addExit(i)};
				if(manifest[i].class == "roundtab"){addRoundTab(i)};
				if(manifest[i].class == "roundcount"){addRoundCount(i)};
				if(manifest[i].class == "playnext"){addPlayNext(i)};
				if(manifest[i].class == "timer"){addTimer(i)};
				if(manifest[i].class == "score"){addScore(i)};
				if(manifest[i].class == "directions"){addDirections(i)};
			}
			
            addGameClass();
			removePreload();  // FUNC in form_styler.js
			
			doBkgMotion();
			
			if(hasDirections == false && hasRounds == false){
				doGameIntro();
			}
			
			if(hasDirections == false && hasRounds == true){
				//doGameIntro();
				playNextIn(0);
			}
			
			//Listening for a tick event that will update the stage
			createjs.Ticker.addEventListener("tick", handleTick);
			createjs.Ticker.framerate = 60;
			createjs.Touch.enable(stage);
			stage.enableMouseOver(10);
        }
		
		/* ::::::::::[ CONTROLS BEGIN ] :::::::::: */

	/* :::::::::: [ ICON FUNCTIONS START ] ::::::::::: */
	/* :::::::::: [ ICON FUNCTIONS START ] ::::::::::: */

		function addIcon(pctIndex){
			var img = queue.getResult(manifest[pctIndex].src);
			var bmp = new createjs.Bitmap(img);
				bmp.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
				bmp.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
				bmp.x = manifest[pctIndex].x;
				bmp.y = manifest[pctIndex].y;
				bmp.z = manifest[pctIndex].z;
				bmp.width = manifest[pctIndex].width;
				bmp.height = manifest[pctIndex].height;
				bmp.scaleX = 1;
				bmp.scaleY = 1;
				bmp.alpha = 1;
				bmp.visible = true;
				bmp.score = manifest[pctIndex].score;
				bmp.hit = false;
				bmp.hitscale = manifest[pctIndex].hitscale;
				bmp.target = manifest[pctIndex].target;
				bmp.time = manifest[pctIndex].time;
				bmp.pause = manifest[pctIndex].pause;
				bmp.timeoffset = manifest[pctIndex].timetweak[0];
				bmp.pauseoffset = manifest[pctIndex].timetweak[1];
				bmp.homex = manifest[pctIndex].x;
				bmp.homey = manifest[pctIndex].y;
				bmp.slot = manifest[pctIndex].slot;
				bmp.killed = false;
				bmp.loopcount = -1;
				bmp.index = iconList.length; //pctIndex;
				stage.addChild(bmp);
				iconList.push(bmp);
		}

	/* :::::::::: [ ICON FUNCTIONS END ] ::::::::::: */
	/* :::::::::: [ ICON FUNCTIONS END ] ::::::::::: */

	/* :::::::::: [ PLAYER FUNCTIONS START ] ::::::::::: */
	/* :::::::::: [ PLAYER FUNCTIONS START ] ::::::::::: */

		function addPlayer(pctIndex){

			var thisIndex = playerList.length;

			var bmpMask = new createjs.Shape();
				bmpMask.graphics.drawRect(0, 0, manifest[pctIndex].width, manifest[pctIndex].height);
				bmpMask.regX = (manifest[pctIndex].width * 0.5);
				bmpMask.regY = (manifest[pctIndex].height * 0.5);	

			var img = queue.getResult(manifest[pctIndex].src);
			var bmp = new createjs.Bitmap(img);
				bmp.regX = Math.round(manifest[pctIndex].width * 0.5);		
				bmp.regY = Math.round(manifest[pctIndex].height * 0.5);		
				bmp.width = manifest[pctIndex].height;
				bmp.height = manifest[pctIndex].width;
				bmp.alpha = 1;
				//bmp.addEventListener("pressmove", playerPressDown);
				//bmp.addEventListener("pressup", playerPressUp);
				bmp.index = thisIndex; //pctIndex;
				bmp.mask = bmpMask;
				bmp.advance = playerspecs.advance; //  - true = player changes when hit || false = only one player icon
				bmp.max = playerspecs.advancemax - 1; //  - max number of advances before starting over
				bmp.count = 0; //  - max number of advances before starting over
				bmp.offset = manifest[pctIndex].height ;
				//bmp.cursor = "pointer";

			var container = new createjs.Container();
				//container.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
				//container.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
				container.x = manifest[pctIndex].x;
				container.y = manifest[pctIndex].y;
				container.width = manifest[pctIndex].width;
				container.height = manifest[pctIndex].height;
				container.alpha = 0;
				container.index = thisIndex;
				container.addEventListener("pressmove", playerPressDown);
				container.addEventListener("pressup", playerPressUp);
				container.active = false; //pctIndex;
				container.inplay = false; // in active playing cycle between player kills
				container.drag = manifest[pctIndex].drag;
				container.homex = manifest[pctIndex].x;
				container.homey = manifest[pctIndex].y;
				container.hit = false;
				container.spin = manifest[pctIndex].spin;
				container.rotation = 0;
				container.cursor = "pointer";
				stage.addChild(container);
				container.addChild(bmp, bmpMask );
			
				playerList.push(container);
				playerBmpList.push(bmp);
						
		} // end addPlayer()
	 
		function playerClick(event) {
			playerIndex = event.target.index;
		 }

	function playerPressDown(event) {

			var dragStyle = playerList[playerIndex].drag;
			playerIndex = event.target.index;
			playerList[playerIndex].active = true;
			playerList[playerIndex].inplay = true;
			
			switch(dragStyle) {
				case "x":
					playerList[playerIndex].x = event.stageX;
					break;
				case "y":
					playerList[playerIndex].y = event.stageY;
					break;
				default:
					playerList[playerIndex].x = event.stageX;
					playerList[playerIndex].y = event.stageY;
			} // end switch
			
		if(playerList[playerIndex].x <= dragMaxLeft ){
			// LEFT BOUNDARY
			playerList[playerIndex].x  = (dragMaxLeft + 2);
		}
		if(playerList[playerIndex].x >= dragMaxRight ){
			// RIGHT BOUNDARY
			playerList[playerIndex].x  = (dragMaxRight - 2);
		}
		if(playerList[playerIndex].y <= dragMaxTop ){
			// TOP BOUNDARY
			playerList[playerIndex].y = (dragMaxTop + 2);
		}
		if(playerList[playerIndex].y >= dragMaxBottom ){
			// TOP BOTTOM
			playerList[playerIndex].y = (dragMaxBottom - 2);
		}

		if(playerList[playerIndex].spin == true){
			
			var dx = playerList[playerIndex].x - dragCenterX;
			var dy =  playerList[playerIndex].y - dragCenterY;
			var radians = Math.atan2(dx,dy);
			playerList[playerIndex].rotation = (radians * 180 / Math.PI) * spinTune;
			
		}
		
		if(timerStarted == false && trackTimer == true ){
			timerStarted = true;
			startTimerGame();
		}
		
		if(iconMotionStarted == false){
			startIconMotion();
		}

	 } // end playerPressDown

	 function playerPressUp(event) {
		playerList[playerIndex].active = false;
	 }  // end playerPressUp

	function trackColllision(){
		
		var thisHit = -1;

		for (i = 0; i < iconList.length; i++) { 

				switch(iconList[i].hit) { // check for icon hits
					case false:
							var dx = iconList[i].x - playerList[playerIndex].x;
							var dy = iconList[i].y - playerList[playerIndex].y;
							var dist = Math.sqrt(dx * dx + dy * dy);
						// if(dist < hitRange && iconList[i].scaleX >= iconList[i].hitscale && playerList[playerIndex].alpha == 1 ){
							if(dist < hitRange && iconList[i].scaleX >= iconList[i].hitscale && playerList[playerIndex].alpha == 1 && playerList[playerIndex].inplay == true  ){
								 // if in range, and Icon scale large enough...
								thisHit = i;
								iconList[i].hit == true;
							} // end dist if
						break;
					default:
						iconList[i].hit = iconList[i].hit;
				} // end iconList[i].hit switch

		} // end icon loop

		if(thisHit > -1 && iconList[thisHit].visible == true  ){ // do tween and sparks
			//iconList[thisHit].hit = true;
			liveHitClass = iconList[thisHit].target;
			liveHitIndex = thisHit;
			advanceTargetIndex = advanceTargetList.indexOf(liveHitClass);
			switch(iconList[thisHit].target) {
				case "icon":
					if(playerAdvance == true && indexOfIcon >= 0 ){
						//hitPlayerTween();
						doPlayerBmpChange();
					}
					if(playerAdvance == false && indexOfIcon >= 0 ){
						playerQuickTween();
					}
					hitIconTween(thisHit);
					break;
				case "player":
					hitPlayerTween();
					break;
				case "icon-player":
					hitPlayerTween();
					hitIconTween(thisHit);
					break;
				default:
					hitIconTween(thisHit);
			} // end iconList[0].target switch
			showPop(thisHit);

			// DO SCORE FOR THIS HIT...
			if(thisHit > -1 && iconList[thisHit ].score != 0 && exitFired == false ){ 
				liveHitClass = iconList[thisHit].target;
				scoreIndex +=  iconList[thisHit].score; //iconIndex;
				if(scoreIndex < 0){scoreIndex = 0};
				if(hasRounds == true){
					trackScoreList[roundsPlayed] += iconList[thisHit].score; 
				}
				changeScore();
			}
			
			if(trackMarker == true){
				markerIndex = liveHitIndex;
				markerTargetScore = iconList[thisHit].score;
				tweenMarker(0);
			}
			
			doKillCheck(); // remove icon from game if hit, or not
			
		} // thisHit if

	}  // end trackColllision()

function hitIconTween(index){
	iconList[index].hit  = true;
	
	var hit00 = createjs.Tween.get(iconList[index])
			.to({alpha:0}, 300, createjs.Ease.sineOut)
			.wait(1000)
			.to({alpha:1}, 300, createjs.Ease.sineIn)
			.call(resetIconHit, [index], this);
		
} // end hitTween

function resetIconHit(index){
	iconList[index].hit = false;
}

function hitPlayerTween(){
	
	if(playerList[playerIndex].hit == false){
		playerList[playerIndex].hit = true;
		playerList[playerIndex].active = false;
		playerList[playerIndex].inplay = false;
		
		doPlayerOut(playerIndex);

	} // end playerList[playerIndex].hit
	
} // end hitTween

function resetPlayerHit(index){
	playerList[playerIndex].hit = false;
}

function doPlayerIn(index){
	// DO PLAYER IN TWEEN...   doPlayerIn(playerIndex);

	var thisPause = playerPauseIn;

	var targetX = playerList[index].homex;
	var targetY = playerList[index].homey;
	
	var playerTimerMax = timerMax - playerTimerCutOff;
	
	//if(exitFired == true || timerCount >= timerMax){
	if(exitFired == true || timerCount >= playerTimerMax){
		playerList[index].visible = false;
	}
	
	if(exitFired == false){  // if game running, show player...
	
		playerList[playerIndex].hit = false;

		playerList[index].x = playerList[index].homex + playerOffsetInX;
		playerList[index].y = playerList[index].homey + playerOffsetInX;
		playerList[index].scaleX = playerScaleInX;
		playerList[index].scaleY = playerScaleInY;
		playerList[index].rotation = playerSpinIn;
		playerList[index].alpha = playerAlphaIn;
		
		doPlayerBmpChange();

		var player00 = createjs.Tween.get(playerList[index])
						.wait(thisPause)
						.call(doPlayerSparksIn)
						.to({
							alpha:1,
							scaleX:1,
							scaleY:1,
							rotation:0,
							x:targetX,
							y:targetY,
						}, playerTimeIn, playerTweenIn)
		.call(addPlayerListener)
		.wait(inPlayPause)
		.call(doInPlayTrue);
		
		if(logEngagement && gameEngaged == false){ logEngagement("game-start") };
		
	} // end exitFired if
	
} // end doPlayerIn(index)

function doPlayerBmpChange(){
	
			if(timerCount > 0 && playerAdvance == true && advanceTargetIndex >= 0  ){ 
			// ROTATE IN NEW PLAYER ICON
			if(playerBmpList[0].max > playerBmpList[0].count ){
				playerBmpList[0].count += 1;
			} else {
				playerBmpList[0].count = 0;
			}
			
			playerBmpList[0].y = (playerBmpList[0].count * playerBmpList[0].offset * -1);
				
			if(trackOffDisplay == true){ // match offPlayerBmp to playerBmp postion
				offPlayerBmpList[0].y = playerBmpList[0].y
			}
			
		}
	
	if(indexOfIcon >= 0){
		playerQuickTween();
	}
}

function playerQuickTween(){
			var tween00 = createjs.Tween.get(playerList[0])
						.to({scaleX:0.9, scaleY:0.9, alpha:0.6}, 150, createjs.Ease.sineIn)
						.to({scaleX:1, scaleY:1, alpha:1}, 150, createjs.Ease.sineOut);
}

function addPlayerListener(){
	if(exitFired == false){
		playerList[playerIndex].addEventListener("pressmove", playerPressDown);
	}
	
}

function doInPlayTrue(){
	if(timerCount > 0 && timerCount < timerMax && exitFired == false){
			playerList[playerIndex].inplay = true;
			console.log("player in @" + timerCount);
		}
}

function doPlayerSparksIn(){
	if(playerSparksIn == true){
	   	addSparkles(0, playerList[playerIndex].x, playerList[playerIndex].y);
	 } // end if
} // doPlayerSparksIn()

function doPlayerOut(index){
	// DO PLAYER EXIT TWEEN...   doPlayerOut(playerIndex);

	var targetX = playerList[index].x + playerOffsetOutX;
	var targetY = playerList[index].y + playerOffsetOutY;
	var targetSpinOut = playerList[index].rotation + playerSpinOut;
	
	playerList[playerIndex].removeEventListener("pressmove", playerPressDown);
		
	if(exitFired == false){
		
			var player01 = createjs.Tween.get(playerList[index])
					.wait(playerPauseOut)
					.to({
						alpha:playerAlphaOut,
						scaleX:playerScaleOutX,
						scaleY:playerScaleOutY,
						rotation:targetSpinOut,
						x:targetX,
						y:targetY,
					}, playerTimeOut, playerTweenOut).call(doPlayerIn, [index], this);
		
	}

	
} // end doPlayerOut(index)

function doPlayerFinalOut(index){
	var targetX = playerList[index].x + playerOffsetOutX;
	var targetY = playerList[index].y + playerOffsetOutY;
	var targetSpinOut = playerList[index].rotation + playerSpinOut;
	
	playerList[playerIndex].removeEventListener("pressmove", playerPressDown);
		
				var player02 = createjs.Tween.get(playerList[index])
					.wait(playerPauseOut)
					.to({
						alpha:playerAlphaOut,
						scaleX:playerScaleOutX,
						scaleY:playerScaleOutY,
						rotation:targetSpinOut,
						x:targetX,
						y:targetY,
					}, playerTimeOut, playerTweenOut)
					.to({alpha:0}, 100, createjs.Ease.sineOut);
		
}

function trackPlayerDisplay(){
	offPlayerList[0].x = playerList[playerIndex].x;
	offPlayerList[0].y = playerList[playerIndex].y;
	offPlayerList[0].rotation = playerList[playerIndex].rotation;
	offPlayerList[0].scaleX = playerList[playerIndex].scaleX;
	offPlayerList[0].scaleY = playerList[playerIndex].scaleY;
	
	var isActiveGame = false;
	var isPlayerActive = playerList[playerIndex].active;
	
	if(exitFired == false && iconMotionStarted == true ){
		isActiveGame = true;
	}
	
	if(isActiveGame == true && isPlayerActive == false ){
		offPlayerList[0].visible = true;
		playerList[playerIndex].alpha = 0.01;
	}
	
	if(isActiveGame == true && isPlayerActive == true ){
		offPlayerList[0].visible = false; 
		playerList[playerIndex].alpha = 1;
	}
	
	if(isActiveGame == false){
		offPlayerList[0].visible = false; 
		playerList[playerIndex].alpha = playerList[playerIndex].alpha;
	}

}

/* :::::::::: [ PLAYER FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ PLAYER FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ EXIT FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ EXIT FUNCTIONS START ] ::::::::::: */
		 
		 function addExit(pctIndex){
				var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
			 		bmp.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
					bmp.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
			 		bmp.width = manifest[pctIndex].width;
					bmp.height = manifest[pctIndex].height;
			 		bmp.offset = manifest[pctIndex].offset;
					bmp.alpha = 0;
			 		bmp.visible = false;
			 		bmp.pause = manifest[pctIndex].pause;
			 		bmp.time = manifest[pctIndex].time;
			 		bmp.cursor = "pointer";
					bmp.index = exitList.length; //pctIndex;
			 		bmp.linkto = manifest[pctIndex].linkto; 
					stage.addChild(bmp);
					bmp.addEventListener("click", exitClick);
					exitList.push(bmp);
			}
	 
		function exitClick(event) {
			exitIndex = event.target.index;
			
			if(exitlinks[0].linkset.length > 1){
				linkTo = exitlinks[0].linkset[exitIndex]; // use index.htm linkto
			} else{
				linkTo = exitList[exitIndex].linkto;  // use content.js linkto
			}
		 
			if(loadQueueLive == true){ // new window for http games...
					switch(linkTo) {
					case "open":
						linkWindow = window.open('', '_blank', windowTools);
						linkWindow.document.body.style.backgroundColor = "#000000";
						break;
					case "banner-open":
						linkWindow = window.open('', '_blank', windowTools);
						linkWindow.document.body.style.backgroundColor = "#000000";
						break;
					default:
						linkTo = linkTo;
					} // end switch
			} // end if loadQueue
			
			
			if(exitlinks[0].gatewaypath != "none"){
				exitAjax();
			} else {
				exitDemo();
			} // end gateway if/else

		 } // end exitClick();

/* :::::::::: [ EXIT FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ EXIT FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ SCORE FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ SCORE FUNCTIONS START ] ::::::::::: */

/*
		var screenScoreShow = roundspecs.showscreenscore; // = true: show score during play || false = hide score during play 
		var exitScoreShow = roundspecs.showexitscore; // = true: show exit pop-up score || false = hide exit pop-up score;
		var showScoreList = [screenScoreShow, exitScoreShow];
*/

		 function addScore(pctIndex){
			
			 var thisOffset = manifest[pctIndex].offset;	
			 var thisIndex = scoreList.length;
			 var thisShowContainer = true;
			 
			 if(hasRounds == true && thisIndex < 2){ // show or hide scores for games games with rounds...
					thisShowContainer = showScoreList[thisIndex];
			 }
			 
			 var scoreMask = new createjs.Shape();
					scoreMask.graphics.drawRect(0, 0, thisOffset, thisOffset);
					scoreMask.regX = (thisOffset * 0.5);
			 		scoreMask.regY = (thisOffset * 0.5);
					scoreMask.x = 0; // manifest[pctIndex].x;
					scoreMask.y = 0; // manifest[pctIndex].y;
			 
			 var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(thisOffset * 0.5);		
					bmp.regY = Math.round(thisOffset * 0.5);		
					bmp.x = 0; // manifest[pctIndex].x;
					bmp.y = 0; // manifest[pctIndex].y;
			 		bmp.width = thisOffset;
			 		bmp.height = thisOffset;
			 		bmp.offset = thisOffset;
			 		bmp.yhome = manifest[pctIndex].y + thisOffset;
					bmp.alpha = 1;
			 		if(thisIndex == 0){
						bmp.visible = true;
					} else {
						bmp.visible = false;
					}
					bmp.index = thisIndex; //pctIndex;
					//stage.addChild(bmp);
			 		bmp.mask = scoreMask;
					scoreList.push(bmp);
			 
			 var container = new createjs.Container();
			 		container.x = manifest[pctIndex].x;
					container.y = manifest[pctIndex].y;
			 		container.visible = thisShowContainer;
			 		stage.addChild(container);
			 		container.addChild(bmp, scoreMask );
			 		scoreContainerList.push(container); // scoreContainerList[0] = standard score, scoreContainerList[1] = popup score
			 
			}

		function changeScore(){

				scoreList[0].alpha = 0
				//scoreList[0].y = scoreList[0].y -= scoreList[0].offset; // move display score
				//scoreList[1].y = scoreList[1].y-= scoreList[1].offset; // move exit sccore
				scoreList[0].y = scoreList[0].y = scoreList[0].offset * scoreIndex * -1; // move display score
				scoreList[1].y = scoreList[1].y = scoreList[0].offset * scoreIndex * -1; // move exit sccore
				scoreList[0].scaleX =  0.1;
				var score01 = createjs.Tween.get(scoreList[0])
					.to({alpha:1, scaleX:1, }, 100, createjs.Ease.sineIn)
					.call(checkGameStatus);
				
		}

/* :::::::::: [ SCORE FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ SCORE FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ TIMER FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ TIMER FUNCTIONS START ] ::::::::::: */

		 function addTimer(pctIndex){
			
			 var thisOffset = manifest[pctIndex].offset;		
			 
			 var timerMask = new createjs.Shape();
					timerMask.graphics.drawRect(0, 0, thisOffset, thisOffset);
					timerMask.regX = (thisOffset * 0.5);
			 		timerMask.regY = (thisOffset * 0.5);
					timerMask.x = manifest[pctIndex].x;
					timerMask.y = manifest[pctIndex].y;
			 
			 var img = queue.getResult(manifest[pctIndex].src);
			 var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(thisOffset * 0.5);		
					bmp.regY = Math.round(thisOffset * 0.5);		
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
			 		bmp.width = thisOffset;
			 		bmp.height = thisOffset;
			 		bmp.offset = thisOffset;
					bmp.alpha = 1;
			 		bmp.visible = manifest[pctIndex].track;
					bmp.index = timerList.length; //pctIndex;
			 		bmp.yhome = manifest[pctIndex].y + thisOffset;
			 		bmp.loopcount = 0;
					stage.addChild(bmp);
			 		bmp.mask = timerMask;
					timerList.push(bmp);
			 
			 		timerMax = manifest[pctIndex].time;
			 		timeSource  = manifest[pctIndex].time;
			 		trackTimer = manifest[pctIndex].track;
			 
					 if(hasRounds == true){
						setRoundsTimer();
					 }
			 
			}

		function startTimerGame(){
			// TRACK SINGLE TIMER FOR WHOLE GAME
			
			if(roundsComplete == false){
				checkGameStatus();
			}
			
				
			if(timerCount < timerMax && exitFired == false){
				timerCount +=1;
				timerList[0].alpha = 0;
				timerList[0].y -= timerList[0].offset;
				timerList[0].scaleX =  0.1;
				var timer01 = createjs.Tween.get(timerList[0])
					.to({alpha:1, scaleX:1, }, 100, createjs.Ease.sineIn)
					.wait(900).call(startTimerGame);
				}
			
		}

/* :::::::::: [ TIMER FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ TIMER FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ DIRECTIONS FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ DIRECTIONS FUNCTIONS START ] ::::::::::: */

		 function addDirections(pctIndex){
			 
			 hasDirections = manifest[pctIndex].track;
			 
				var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(manifest[pctIndex].width * 0.5);	
					bmp.regY = Math.round(manifest[pctIndex].height * 0.5);	
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
			 		bmp.width = manifest[pctIndex].width;
			 		bmp.height = manifest[pctIndex].height;
					bmp.alpha = 1;
			 		bmp.visible = manifest[pctIndex].track;
					bmp.index = directionList.length; //pctIndex;
					bmp.cursor = "pointer";
					stage.addChild(bmp);
					//bmp.addEventListener("click", directionClick);
					directionList.push(bmp);
			 
			 if(hasDirections == true){
				 doDirectionsIn(0);
			 }
			 
			}

		function directionClick(event){
			doDirectionsOut(0);

		}

function doDirectionsIn(index){
	// DO DIRECTIONS INTRO ON CANVAS DISPLAY

	var thisPause = drcPauseIn;

	var targetX = directionList[index].x;
	var targetY = directionList[index].y;
	
	directionList[index].x = directionList[index].x + drcOffsetInX;
	directionList[index].y = directionList[index].y + drcOffsetInX;
	directionList[index].scaleX = drcScaleInX;
	directionList[index].scaleY = drcScaleInY;
	directionList[index].rotation = drcSpinIn;
	directionList[index].alpha = drcAlphaIn;
	
	var direction00 = createjs.Tween.get(directionList[index])
					.wait(thisPause)
					.call(showDrcSparksIn)
					.to({
						alpha:1,
						scaleX:1,
						scaleY:1,
						rotation:0,
						x:targetX,
						y:targetY,
					}, drcTimeIn, drcTweenIn)
			.call(addDirectionEvent);

}

function addDirectionEvent(){
	directionList[0].addEventListener("click", directionClick);
}

function showDrcSparksIn(){
	if(drcSparksIn == true){
	   	addSparkles(0, directionList[0].x, directionList[0].y)
	 }
}

function doDirectionsOut(index){
	// DO DIRECTIONS EXIT...

	var targetX = directionList[index].x + drcOffsetOutX;
	var targetY = directionList[index].y + drcOffsetOutY;
	
	directionList[index].removeAllEventListeners();
	
	var direction00 = createjs.Tween.get(directionList[index])
					.wait(drcPauseOut)
					.to({
						alpha:drcAlphaOut,
						scaleX:drcScaleOutX,
						scaleY:drcScaleOutY,
						rotation:drcSpinOut,
						x:targetX,
						y:targetY,
					}, drcTimeOut, drcTweenOut).call(startDirections);
	
		
	if(drcSparksOut == true){
	   	addSparkles(0, directionList[index].x, directionList[index].y)
	 }
	
	
}

function startDirections(){
	doPlayerIn(playerIndex);
	//startIconMotion();
}
/* :::::::::: [ DIRECTIONS FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ DIRECTIONS FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ ROUND TAB START ] ::::::::::: */
/* :::::::::: [ ROUND TAB START ] ::::::::::: */
/* :::::::::: [ ROUND TAB START ] ::::::::::: */

function addRoundTab(pctIndex){
			
			 var thisOffset = manifest[pctIndex].offset;	
			 var thisIndex = roundTabList.length;
			 
			 var roundTabMask = new createjs.Shape();
					roundTabMask.graphics.drawRect(0, 0, manifest[pctIndex].width, manifest[pctIndex].height);
					roundTabMask.regX = (manifest[pctIndex].width * 0.5);
			 		roundTabMask.regY = (manifest[pctIndex].height * 0.5);
					roundTabMask.x = 0; // manifest[pctIndex].x;
					roundTabMask.y = 0; // manifest[pctIndex].y;
			 
			 var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(manifest[pctIndex].width * 0.5);		
					bmp.regY = Math.round(manifest[pctIndex].height * 0.5);		
					bmp.x = 0; // manifest[pctIndex].x;
					bmp.y = 0; // manifest[pctIndex].y;
			 		bmp.width = manifest[pctIndex].width;
			 		bmp.height = manifest[pctIndex].height;
			 		bmp.offset = thisOffset;
					bmp.offsetx = manifest[pctIndex].width;
					bmp.offsety = manifest[pctIndex].height;
					bmp.xhome = 0;
					bmp.yhome = manifest[pctIndex].y + thisOffset;
					bmp.moved = false;
			 		bmp.round = 0;
					bmp.alpha = 1;
					bmp.index = thisIndex; //pctIndex;
			 		bmp.mask = roundTabMask;
					roundTabList.push(bmp);
			 
			 var container = new createjs.Container();
			 		container.x = roundTabListX[0]; //manifest[pctIndex].x;
					container.y = roundTabListY[0]; //manifest[pctIndex].y;
			 		stage.addChild(container);
			 		container.addChild(bmp, roundTabMask );
			 		roundTabContainerList.push(container); // 
			 
			}

		function changeRoundTab(){
			
			console.log(
				" changeRoundTab() ++++++++++ roundsPlayed=" + roundsPlayed + " roundIndex" + roundIndex + 
				" roundWinList=" + roundWinList + " roundSuccess=" + roundSuccess + " x" + roundTabListX[roundIndex]
			);
			
			roundTabList[0].round = roundSuccessList.length;
						
			if(exitFired == false){
				roundTabList[0].alpha = 0;
				roundTabList[0].x =  roundTabList[0].xhome;
				//roundTabList[0].y -= roundTabList[0].offset;
				roundTabList[0].y = (roundIndex * roundTabList[0].offsety) * -1;
				roundTabList[0].scaleX =  0.1;

				var roundTab00 = createjs.Tween.get(roundTabList[0])
					.to({alpha:0, scaleX:1, }, 100, createjs.Ease.sineIn)
					.call(moveRoundContainer)
					.wait(500)
					.to({alpha:1, scaleX:1, }, 500, createjs.Ease.sineOut);
				}
			
		}

		function moveRoundContainer(){
 
			roundTabContainerList[0].x = roundTabListX[roundIndex];
			roundTabContainerList[0].y = roundTabListY[roundIndex];
			
		}

		function replayRoundTab(){
			
			//console.log(" replayRoundTab() ----------  roundsPlayed=" + roundsPlayed + " roundIndex" + roundIndex + " roundWinList=" + roundWinList);
			
			var thisOffsetX = (roundsPlayed - roundIndex) * roundTabList[0].offsetx * -1;
			var thisOffsetY = (roundIndex * roundTabList[0].offsety) * -1;
						
			//roundTabList[0].x -= roundTabList[0].offsetx;
			
			var roundTab00 = createjs.Tween.get(roundTabList[0])
					.to({alpha:0, }, 400, createjs.Ease.sineIn)
					.to({x:thisOffsetX, y:thisOffsetY }, 100, createjs.Ease.linear)
					.wait(500)
					.to({alpha:1, }, 500, createjs.Ease.sineIn);
			
		}

		function doRoundTabSwitch(){
				if(roundSuccess == true){
					changeRoundTab();
				} else {
					replayRoundTab();
				}
		}

/* :::::::::: [ ROUND TAB END ] ::::::::::: */
/* :::::::::: [ ROUND TAB END ] ::::::::::: */
/* :::::::::: [ ROUND TAB END ] ::::::::::: */

/* :::::::::: [ ROUND COUNTER START ] ::::::::::: */
/* :::::::::: [ ROUND COUNTER START ] ::::::::::: */
/* :::::::::: [ ROUND COUNTER START ] ::::::::::: */

function addRoundCount(pctIndex){
			
			 var thisOffset = manifest[pctIndex].offset;		
			 
			 var roundCountMask = new createjs.Shape();
					roundCountMask.graphics.drawRect(0, 0, thisOffset, thisOffset);
					roundCountMask.regX = (thisOffset * 0.5);
			 		roundCountMask.regY = (thisOffset * 0.5);
					roundCountMask.x = manifest[pctIndex].x;
					roundCountMask.y = manifest[pctIndex].y;
			 
			 var img = queue.getResult(manifest[pctIndex].src);
			 var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(thisOffset * 0.5);		
					bmp.regY = Math.round(thisOffset * 0.5);		
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
			 		bmp.width = thisOffset;
			 		bmp.height = thisOffset;
			 		bmp.offset = thisOffset;
					bmp.alpha = 1;
			 		bmp.visible = true;
					bmp.homey = manifest[pctIndex].y;
					bmp.index = roundCountList.length; //pctIndex;
			 		bmp.yhome = manifest[pctIndex].y + thisOffset;
			 		bmp.loopcount = 0;
					stage.addChild(bmp);
			 		bmp.mask = roundCountMask;
					roundCountList.push(bmp);
			 
			}

function doNextRoundCount(){
	
	roundCountList[0].loopcount += 1;
	
	var nextY = roundCountList[0].homey - (roundCountList[0].loopcount * roundCountList[0].offset);
	
	var roundcount00 = createjs.Tween.get(roundCountList[0])
									.to({alpha:0}, 300, createjs.Ease.sineIn)
									.to({y:nextY }, 200, createjs.Ease.linear)
									.to({alpha:1}, 500, createjs.Ease.sineOut);
	
}

/* :::::::::: [ ROUND COUNTER END ] ::::::::::: */
/* :::::::::: [ ROUND COUNTER END ] ::::::::::: */
/* :::::::::: [ ROUND COUNTER END ] ::::::::::: */


/* :::::::::: [ PLAY NEXT ROUND BTN START ] ::::::::::: */
/* :::::::::: [ PLAY NEXT ROUND BTN START ] ::::::::::: */
/* :::::::::: [ PLAY NEXT ROUND BTN START ] ::::::::::: */

	function addPlayNext(pctIndex){
			
			var thisLength = (playNextCount); 
			var thisOffset = playnextspecs.offset;
		
			trackPlayNext = manifest[pctIndex].track;
			
			for (k = 0; k < thisLength; k++) { 
				
				var thisIndex = k; 

				var playnextMask = new createjs.Shape();
						playnextMask.graphics.drawRect(0, 0, thisOffset, thisOffset);
						playnextMask.regX = (thisOffset * 0.5);
						playnextMask.regY = (thisOffset * 0.5);
						playnextMask.x = 0; // manifest[pctIndex].x;
						playnextMask.y = 0; // manifest[pctIndex].y;

				 var img = queue.getResult(manifest[pctIndex].src);
				 var bmp = new createjs.Bitmap(img);
						bmp.regX = Math.round(manifest[pctIndex].width * 0.5 );
						bmp.regY = Math.round(manifest[pctIndex].height * 0.5 );
						bmp.x = 0;
						bmp.y = thisOffset * k * -1;
						bmp.width = manifest[pctIndex].width;
						bmp.height = manifest[pctIndex].height;
						bmp.offset = thisOffset;
						bmp.alpha = 1; 
						bmp.index = thisIndex;
						bmp.visible = true;
						bmp.mask = playnextMask;
						bmp.moved = false;
						bmp.homex = 0;
						bmp.clicked = false;
						bmp.clickcount = 0;
						bmp.addEventListener("click", playNextClick);
						playNextBmpList.push(bmp);

					var container = new createjs.Container();
						container.x = playnextspecs.playnextx[thisIndex];
						container.y = playnextspecs.playnexty[thisIndex];
						container.z = k;
						container.index = thisIndex; //playNextContainerList.length;
						container.alpha = playnextspecs.alphain;
						container.scaleX = 0;
						container.scaleY = 0;
						container.rotation = 0;
						container.homex = playnextspecs.playnextx[thisIndex];
						container.homey = playnextspecs.playnexty[thisIndex];
						container.cursor = "pointer";
						container.visible = false;
						stage.addChild(container);
				
						container.addChild(bmp, playnextMask  );
						playNextContainerList.push(container);
				
								
			} // end loop
			
		} // end addPlayNext

function playNextClick(){
	playNextTarget += 1;
	if(roundSuccess == true){
		playNextOut(roundIndex);
	} else {
		playNextOutFallback(playNextIndex);
		startPlayerInRound();
	}
		
}

function playNextIn(index){
	
	// TWEEN IN PLAY NEXT
	var thisIndex = index;
	
	playNextBmpList[thisIndex].x = playNextBmpList[thisIndex].homex; // reset bmp
	
	if(roundSuccess == false && roundReplay == true ){
		//console.log("REPLAY THIS ROUND ------- round=" + roundIndex);
		roundIndex -=1;
		thisIndex -=1;
		playNextBmpList[thisIndex].x = (playNextBmpList[thisIndex].offset * -1);
		trackRoundsList[roundsPlayed] = roundIndex;
		playNextBmpList[roundIndex].clicked = false;
		resetRoundMarkers();
		resetPlayNext();
	}
	
	playNextIndex = thisIndex;
	
	var targetX = playNextContainerList[thisIndex].homex;
	var targetY = playNextContainerList[thisIndex].homey;
	var plusOrMinus = Math.random() < 0.5 ? -1 : 1;
	
	playNextContainerList[thisIndex].visible = true;
	playNextContainerList[thisIndex].x = targetX + playNextInX;
	playNextContainerList[thisIndex].y = targetY + playNextInY;
	playNextContainerList[thisIndex].alpha = playNextAlphaIn;
	playNextContainerList[thisIndex].rotation = playNextSpinIn * plusOrMinus;
	playNextContainerList[thisIndex].scaleX = playNextScaleInX;
	playNextContainerList[thisIndex].scaleY = playNextScaleInY;
	
	var playIn00 = createjs.Tween.get(playNextContainerList[thisIndex])
							.wait(playNextPauseIn)
							//.call(doPlayerRoundOut)
							.call(doRoundClose)
							.to({x:targetX, y:targetY, alpha:1, scaleX:1, scaleY:1, rotation:0}, playNextTimeIn, playNextTweenIn)
							.call(doRoundNext);
	
	playerList[playerIndex].inplay == false;

	var playerOut00 = createjs.Tween.get(playerList[playerIndex]).to({alpha:0, visible:false}, 333, createjs.Ease.sineInOut);
							
	
	if(playNextSpaksIn == true){
		addSparkles(0, playNextContainerList[thisIndex].homex, playNextContainerList[thisIndex].homey);
	}
	
}

function playNextOut(index){
	// TWEEN OUT PLAY NEXT
	if(playNextBmpList[roundIndex].clicked == false){
		
			var thisIndex = index;
			var targetX = playNextContainerList[thisIndex].homex + playNextOutX;
			var targetY = playNextContainerList[thisIndex].homey + playNextOutY;
			var plusOrMinus = Math.random() < 0.5 ? -1 : 1;
			var targetSpin = playNextSpinOut * plusOrMinus;
		
			playNextBmpList[roundIndex].clicked = true;

			var playOut00 = createjs.Tween.get(playNextContainerList[thisIndex])
									.wait(playNextPauseOut)
									.to({x:targetX, y:targetY, alpha:playNextAlphaOut, scaleX:playNextScaleOutX, scaleY:playNextScaleOutY, rotation:targetSpin}, playNextTimeOut, playNextTweenOut)
									.call(doNextRoundCount)
									.call(startPlayerInRound)
									.call(resetMarkers)
									.call(doRoundTabSwitch);

			if(playNextSparksOut == true){
				addSparkles(0, playNextContainerList[thisIndex].homex, playNextContainerList[thisIndex].homey);
			}
		} // end if playNextBmpList[thisIndex].clicked
	
	if(roundSuccess == false && roundReplay == true ){
		roundSuccess = true;
	}
	
}

function playNextOutFallback(index){
	// TWEEN OUT PLAY NEXT, !! FORCED TWEEN FOR GLITECHED CLICK GLICTCHED CLICK
	var thisIndex = index;
	var targetX = playNextContainerList[thisIndex].homex + playNextOutX;
	var targetY = playNextContainerList[thisIndex].homey + playNextOutY;
	var plusOrMinus = Math.random() < 0.5 ? -1 : 1;
	var targetSpin = playNextSpinOut * plusOrMinus;
	
	
	var playOut00 = createjs.Tween.get(playNextContainerList[thisIndex])
							.wait(playNextPauseOut)
							.to({x:targetX, y:targetY, alpha:playNextAlphaOut, scaleX:playNextScaleOutX, scaleY:playNextScaleOutY, rotation:targetSpin}, playNextTimeOut, playNextTweenOut)
							.call(doNextRoundCount)
							.call(resetMarkers)
							.call(doRoundTabSwitch);
	
}

function startPlayerInRound(){
	doPlayerInRound(0);
	
	// SHOW ICONS FOR THIS ROUND
	for (i = 0; i < iconList.length; i++) { 
		if(iconList[i].z == roundIndex){
			iconList[i].killed = false;
		}
	}
	
	//resetMarkers();
	//doRoundTabSwitch();
	
}

//markerContainerList[i]

function resetMarkers(){
	// HIDE MARKER FOR PREVIOUS ROUNDS
	if(markerShowOnRound == true){
		//for (i = 0; i < iconList.length; i++) { 
		for (i = 0; i < markerContainerList.length; i++) { 
			if(markerContainerList[i].z < roundIndex){
 				var tween00 = createjs.Tween.get(markerContainerList[i]).to({alpha:0}, 500, createjs.Ease.sineIn);
				if(markerBmpList[i].moved == true){
					// RESET MARKER BACK TO SHOW POSITIVE ICON...
					markerBmpList[i].moved == false;
					var newX = markerBmpList[markerIndex].x + markerBmpList[markerIndex].offset;;
					var move00 = createjs.Tween.get(markerBmpList[i])
											.wait(500)				
											.to({x:newX}, 500, createjs.Ease.sineIn);
				}
			} else{
				markerBmpList[i].moved = false;
				markerBmpList[i].complete = false;
				markerBmpList[i].x = markerBmpList[i].homex;
			}
		} // end for iconList
	} // if end markerShowround 
}

function resetRoundMarkers(){
		// RESET MARKER TO REPLAY ROUND
		for (i = 0; i < markerContainerList.length; i++) { 
			if(markerContainerList[i].z == roundIndex){
 				var tween00 = createjs.Tween.get(markerContainerList[i]).to({alpha:0}, 500, createjs.Ease.sineIn);
				if(markerBmpList[i].moved == true){
					// RESET MARKER BACK TO SHOW POSITIVE ICON...
					markerBmpList[i].moved == false;
					var newX = markerBmpList[markerIndex].x + markerBmpList[markerIndex].offset;;
					var move00 = createjs.Tween.get(markerBmpList[i])
											.wait(500)				
											.to({x:newX}, 500, createjs.Ease.sineIn);
				}
			} // end if roundIndex
		} // end for iconList
}

function resetPlayNext(){
		// RESET MARKER TO REPLAY ROUND
		for (i = 0; i < playNextContainerList.length; i++) { 
			if(playNextContainerList[i].z == roundIndex){
 				var tween00 = createjs.Tween.get(playNextContainerList[i]).to({alpha:0}, 500, createjs.Ease.sineIn);
				if(playNextBmpList[i].moved == true){
					// RESET MARKER BACK TO SHOW POSITIVE ICON...
					playNextBmpList[i].moved == false;
					var newX = playNextBmpList[markerIndex].x + playNextBmpList[markerIndex].offset;
					var move00 = createjs.Tween.get(playNextBmpList[i])
											.wait(500)				
											.to({x:newX}, 500, createjs.Ease.sineIn);
				}
			} // end if roundIndex
		} // end for iconList
}



/* :::::::::: [ PLAY NEXT ROUND BTN END ] ::::::::::: */
/* :::::::::: [ PLAY NEXT ROUND BTN END ] ::::::::::: */
/* :::::::::: [ PLAY NEXT ROUND BTN END ] ::::::::::: */

function startIconMotion(){
	
	iconMotionStarted = true;
	
	for (i = 0; i < iconList.length; i++) { 
		loopIconTween(i);
	}
	
}

function loopIconTween(index){
	
	var plusMinusX = Math.random() < 0.5 ? -1 : 1;
	var plusMinusY = Math.random() < 0.5 ? -1 : 1;
	var plusMinusSpin = Math.random() < 0.5 ? -1 : 1;
	var IndexRandomIn = Math.floor( Math.random() * iconInXlist.length );
	var IndexRandomOut = Math.floor( Math.random() * iconOutXlist.length );
	var IndexRandomInX = Math.floor( Math.random() * iconInXlist.length );
	var IndexRandomInY = Math.floor( Math.random() * iconInYlist.length );
	var IndexRandomOutX = Math.floor( Math.random() * iconOutXlist.length );
	var IndexRandomOutY = Math.floor( Math.random() * iconOutYlist.length );
	var hasOverlap = false;
	
	// XY START VALUES
	var startX = Math.round( iconInXlist[IndexRandomIn] + ( Math.random() * iconOffsetXIn * plusMinusX)  );
	var startY = Math.round( iconInYlist[IndexRandomIn] + ( Math.random() * iconOffsetYIn * plusMinusY) );
	var startSpin = ( Math.random() * iconSpinIn * plusMinusSpin);

	// XY END VALUES
	var targetX = iconOutXlist[IndexRandomIn] + ( Math.random() * iconOffsetXOut * plusMinusX);
	var targetY = iconOutYlist[IndexRandomIn] + ( Math.random() * iconOffsetYOut * plusMinusY);
	
	var thisTime = iconList[index].time+ Math.round( Math.random() * iconList[index].timeoffset )
	var thisPause = iconList[index].pause + Math.round( Math.random() * iconList[index].pauseoffset );
	
	var overlapIndex = -1;
	
	iconList[index].loopcount += 1;
	
	if(iconList[index].loopcount == 0){
		var introOffset = Math.round( iconList[index].pauseoffset * Math.random() );
		thisPause = iconList[index].pause + Math.round(iconList[index].pauseoffset * index * 0.3) + introOffset;
	}
	
	
		for (j = 0; j < iconList.length; j++) { 
			if(j != index){

					var distMin = iconList[index].width;
					var dx = iconList[j].x - startX;
					var dy = iconList[j].y - startY;
					var dist = Math.sqrt(dx * dx + dy * dy);
					if(dist < distMin && iconList[index].loopcount != 0){
						hasOverlap = true;
						overlapIndex = j;
					} // if dst

			} // if j
		} // end loop
	
	if(hasOverlap == true){
		
	}	
	// NEW XY POSTIONS FOR OVERLAP ISSUEs
	
		switch(iconExitClass) {
			case "x":
				targetY = startY; // horizontal only
				if(hasOverlap == true && iconOffsetYIn > 0){ 
					//var newMaxBottom = dragMaxBottom - (iconList[index].regY * 2) ;
					var newMaxBottom = dragMaxBottom - Math.round(iconList[index].height * 1.5);
					startY = targetY  = dragMaxTop + Math.round( Math.random() * newMaxBottom ); //targetY = targetList[indexRandom];
					thisPause += iconList[index].pauseoffset;
				}
				break;
			case "y":
				targetX = startX;  // vertical only
				if(hasOverlap == true && iconOffsetXIn > 0){ 
					//var newMaxRight = dragMaxRight - iconList[index].regX ;
					var newMaxRight = dragMaxRight - Math.round(iconList[index].width * 1.5) ;
					startX = targetX  = dragMaxLeft + Math.round( Math.random() * newMaxRight ); 
					thisPause += iconList[index].pauseoffset;
				}
				break;
			case "xy":
				targetX = iconOutXlist[IndexRandomOut] + ( Math.random() * iconOffsetXOut * plusMinusX);
				targetY = iconOutYlist[IndexRandomOut] + ( Math.random() * iconOffsetYOut * plusMinusY);
				break;
			default:
				iconExitClass = iconExitClass;
		} // iconExitClass
	
	// FINAL START POSTION
	iconList[index].x = startX; 
	iconList[index].y = startY; 
	iconList[index].alpha = iconAlphaIn;
	iconList[index].rotation = startSpin;
	iconList[index].scaleX = iconScaleXin; // 0
	iconList[index].scaleY = iconScaleYin; // 0
	iconList[index].hit = false; // 0
	if(iconActiveShow == true){
	   iconList[index].visible = playerList[playerIndex].active; 
	   } else {
	   	iconList[index].visible = true; 
	   }
	
	if( playerList[playerIndex].inplay == false){
		iconList[index].visible = false; 
	}
	
	if( playerList[playerIndex].inplay == true){
		iconList[index].visible = true; 
	}
	
	if(iconList[index].killed == true){
		iconList[index].visible = false; 
	}
	
	if(iconList[index].z != roundIndex){ // hide icon if not in current round...
		iconList[index].visible = false; 
	}
		
	if(exitFired == false  ){
		
		var icon00 = createjs.Tween.get(iconList[index])
			.wait(thisPause)	
			.to({alpha:1, x:targetX, y:targetY, rotation:0, scaleX:iconScaleOutX, scaleY:iconScaleOutY }, thisTime, createjs.Ease.sineOut)
			.call(loopIconTween, [index], this);
		
	} // end exitFired 
	
}

/* :::::::::: [ checkGameStatus FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ checkGameStatus FUNCTIONS START ] ::::::::::: */

function checkGameStatus(){
	var runExit = false;
	var isLastRound = false;
	var playNextFired = false;
	var roundComplete = false;
	
	/* :::::::::: [ ONE ROUND CHECKS ] ::::::::::: */
	/* :::::::::: [ ONE ROUND CHECKS ] ::::::::::: */
	if(scoreIndex >= scoreMax && hasRounds == false){
		runExit = true;
	}
	
	if(timerCount == timerMax  && hasRounds == false){
		runExit = true;
	}
	
	/* :::::::::: [ MULTI-ROUND CHECKS ] ::::::::::: */
	/* :::::::::: [ MULTI-ROUND CHECKS ] ::::::::::: */
	//if(roundIndex == lastRoundIndex && hasRounds == true){ // roundMax
	if(roundsPlayed == lastRoundIndex && hasRounds == true){ // roundMax
	//if(roundIndex == roundMax && hasRounds == true){ // lastRoundIndex
		isLastRound = true;
	}
	
	// if score met or time runs out, round is complete
	if(trackScoreList[roundsPlayed] >= scoreMax || timerCount >= timerMax ){
		roundComplete = true;
		if(trackScoreList[roundsPlayed] >= scoreMax){ roundSuccess = true };
	}

	// END ROUND ON SCORE
	//if(scoreIndex == scoreMax && isLastRound == true){ // show exit on last round score
	if(trackScoreList[roundsPlayed] >= scoreMax && isLastRound == true){ // show exit on last round score
		roundSuccess = true;
		runExit = true;
		logActiveRound();
	}
	// END ROUND ON TIMER
	if(timerCount == timerMax && isLastRound == true){ // show exit on last round timer
		if(trackScoreList[roundsPlayed] < scoreMax){ roundSuccess = false }; // roundSuccess false if less than required score
		runExit = true;
		logActiveRound();
	}
	
	if(hasRounds == true && isLastRound == false && trackScoreList[roundsPlayed] < roundScoreMaxList[roundIndex] ){
		roundSuccess = false;
	}
	
	/*if(hasRounds == true && roundSuccess == true){
		roundWinList[roundIndex] = 1;
		var thisEngagement = "roundwin-" + (roundIndex + 1);
		if(logEngagement){ logEngagement(thisEngagement) };
	}*/
	
	if(roundSuccess == true && roundSuccessList.length <= lastRoundIndex && trackScoreList[roundsPlayed] == roundScoreMaxList[roundIndex]  ){
		roundSuccessList.push(roundSuccess);
		roundWinList[roundIndex] = 1;
		var thisEngagement = "roundwin-" + (roundIndex + 1);
		if(logEngagement){ logEngagement(thisEngagement) };
		console.log("???????? checkGameStatus() lastRoundIndex" + lastRoundIndex + " roundSuccessList=" + roundSuccessList + " isLastRound=" + isLastRound + " roundsPlayed=" + roundsPlayed )
	}
	
	if(hasRounds == true && roundComplete == true && isLastRound == false && playNextFired == false){
		runExit = false;
		playNextFired = true;
		roundIndex += 1;
		roundsPlayed += 1;
		playNextIn(roundIndex);
		logActiveRound();
	}
	
	/* :::::::::: [ FINAL EXIT CHECK ] ::::::::::: */
	/* :::::::::: [ FINAL EXIT CHECK ] ::::::::::: */
	if(exitFired == false && runExit== true){ 
		roundsComplete = true;
		showExit();
	}
		
} // end checkGameStatus()

function logActiveRound(){
	trackRoundsList[roundsPlayed] = roundIndex;
	if(gameclass != "live" ){
		console.log("ROUND COMPLETE ::: roundsPlayed=" + roundsPlayed + " : roundIndex=" + roundIndex + " : scoreThisRound=" + trackScoreList[roundsPlayed] + " roundWinList=" + roundWinList );
	}
}

function doRoundNext(){
	
	// RESET SCORE
	scoreMin = roundScoreMinList[roundIndex];
	scoreMax = roundScoreMaxList[roundIndex];
	scoreList[0].y = scoreList[0].yhome;
	
	setRoundsTimer();
	
	// reset player 
	playerBmpList[0].count = 0; // or -1 if 0 doesn't work
	playerBmpList[0].y = (playerBmpList[0].count * playerBmpList[0].offset * -1);
	
	if(trackOffDisplay == true){ // match offPlayerBmp to playerBmp
		offPlayerBmpList[0].y = playerBmpList[0].y
	}
	
	if(roundSparks == true){
		var centerWidth = Math.round(version.canvas[0] * 0.5);
		var centerHeight = Math.round(version.canvas[1] * 0.5);
		addSparkles(0, centerWidth , centerHeight);
	}
	
}

function doRoundClose(){
	// METHODS TO CLOSE CURRENTLY ACTIVE ROUND
	playerList[playerIndex].inplay == false;
	
	createjs.Tween.removeTweens(timerList[0]);
	
	// HIDE ICONS FOR LAST AND CURRENT ROUND FOR SCENE TRANSITION
	for (i = 0; i < iconList.length; i++) { 
		if(iconList[i].z <= roundIndex){
			iconList[i].killed = true;
			var iconOut = createjs.Tween.get(iconList[i])
					.to({alpha:0}, 333, createjs.Ease.sineIn)
					.to({visible:false}, 100, createjs.Ease.linear);
		}
	}
	
	
}

function doPlayerRoundOut(){

	// DO PLAYER EXIT TWEEN...   doPlayerOut(playerIndex);

	var targetX = playerList[index].x + playerOffsetOutX;
	var targetY = playerList[index].y + playerOffsetOutY;
	var targetSpinOut = playerList[index].rotation + playerSpinOut;
	
	playerList[playerIndex].removeEventListener("pressmove", playerPressDown);
	playerList[playerIndex].inplay = false;
		
	if(exitFired == false){
		
			var player01 = createjs.Tween.get(playerList[index])
					.wait(playerPauseOut)
					.to({
						alpha:playerAlphaOut,
						scaleX:playerScaleOutX,
						scaleY:playerScaleOutY,
						rotation:targetSpinOut,
						x:targetX,
						y:targetY,
					}, playerTimeOut, playerTweenOut);
		
	}

	
}


function setRoundsTimer(){
	
	// RESET TIMER
	var timeOffset = timeSource - roundTimeList[roundIndex];
	timerMax = timeSource -  timeOffset; // roundTimeList[roundIndex];
	timerCount = 0;
	timerList[0].y = (timerList[0].yhome - (timerList[0].offset * timeOffset ) - timerList[0].offset );
	
}


function doPlayerInRound(index){
	// DO PLAYER IN TWEEN...   doPlayerIn(playerIndex);

	var thisPause = playerPauseIn;

	var targetX = playerList[index].homex;
	var targetY = playerList[index].homey;
	
	var playerTimerMax = timerMax - playerTimerCutOff;

	if(exitFired == true){
		//playerList[index].visible = false;
	}
	
	if(exitFired == false){  // if game running, show player...
	
		playerList[playerIndex].hit = false;
		playerList[index].visible = true;

		playerList[index].x = playerList[index].homex + playerOffsetInX;
		playerList[index].y = playerList[index].homey + playerOffsetInX;
		playerList[index].scaleX = playerScaleInX;
		playerList[index].scaleY = playerScaleInY;
		playerList[index].rotation = playerSpinIn;
		playerList[index].alpha = playerAlphaIn;
		
		// RESET PLAYER BMP...
		playerBmpList[0].count = 0;
		playerBmpList[0].y = (playerBmpList[0].count * playerBmpList[0].offset * -1);
		
		if(trackOffDisplay == true){// match offPlayerBmp to playerBmp postion
			offPlayerBmpList[0].y = playerBmpList[0].y
		}

		var player00 = createjs.Tween.get(playerList[index])
						.wait(thisPause)
						.call(doPlayerSparksIn)
						.to({
							alpha:1,
							scaleX:1,
							scaleY:1,
							rotation:0,
							x:targetX,
							y:targetY,
							visible:true,
						}, playerTimeIn, playerTweenIn)
		.call(addPlayerListener)
		.call(changeScore)
		.wait(inPlayPause)
		.call(doInPlayTrue)
		.call(startRoundsTimer);
				
	} // end exitFired if
	
	function startRoundsTimer(){
		createjs.Tween.removeTweens(timerList[0]);
		startTimerGame();
	}
	
} // end function

function doGameIntro(){
	doPlayerIn(playerIndex);
}

function doLastRoundMath(){
	var thisScoreTotal = 0;
	var thisExitClass = exitlinks[0].gateclass;
	var thisRequiredScore = 0;
	var thisRoundsPlayed = roundsPlayed + 1;
	
	for (i = 0; i < thisRoundsPlayed; i++) { 
		thisRequiredScore += roundScoreMaxList[i];
	}
	
	for (i = 0; i < trackScoreList.length; i++) { 
		thisScoreTotal += trackScoreList[i];
	}
	
	for (i = 0; i < roundWinList.length; i++) { 
		roundWinCount += roundWinList[i];
	}
	
	switch(thisExitClass) {
		case "multiexit":
			if(roundWinClass == "points"){ // socre on total points accumulated
				if(thisScoreTotal < 11){
					scoreIndex = thisScoreTotal;
				} else { scoreIndex = 10 }
			}
			if(roundWinClass == "rounds"){ // score on total rounds won
				scoreIndex = roundWinCount;
			}
			break;
		case "score":
			scoreIndex = thisScoreTotal;
			scoreMin = thisRequiredScore;
			break;
		default:
			scoreIndex = thisScoreTotal;
	}
	
	if(roundWinClass == "rounds"){
		choiceList = [];
		choiceList.push(roundWinCount);
	}
	var finalScoreLog = "roundwins-" + roundWinCount;
	if(logEngagement){ logEngagement(finalScoreLog) };
	
	if(gameclass != "live"){
		console.log(">>>>>>>>>>>>>>> doLastRoundMath roundWinClass=" + roundWinClass + " roundWinCount=" + roundWinCount + " scoreIndex=" + scoreIndex + " roundWinList=" + roundWinList + 
					" roundSuccessList=" + roundSuccessList);
	}
	
		
}

function showExit(){
	
	if(hasRounds == true && exitFired == false){
		doLastRoundMath();
		doNextRoundCount();
	}
	
	exitFired = true;
	trackOffDisplay == false;
	
	var thisExitClass = exitlinks[0].gateclass;
	
	switch(thisExitClass) {
		case "multiexit":
			if(scoreIndex < 11){
				exitIndex = scoreIndex;
			} else { exitIndex = 10 }
			break;
		case "score":
			// NORMAL SCORE CONDITIION
			if(scoreIndex < scoreMin){ 
				exitIndex = 0
			} else {
				exitIndex = 1;
			}
			// INVERT/FLIP scoreIndex FOR 'avoid' STYLE GAME....
			if(scoreClass == "invert"){ 
				if(scoreIndex < scoreMin){ 
					exitIndex = 1 // show win for not being hit too much
				} else {
					exitIndex = 0; // show loss for too many hits
				}
			}
			break;
		case "choice":
				exitIndex = choiceList[choiceList.length - 1];
			break;
		default:
			exitIndex = winlevel;
	}
	
	if(hasRounds == true && roundWinClass == "rounds" && thisExitClass== "multiexit" ){exitIndex = roundWinCount }
				
	var finalExitY = exitList[exitIndex].y; 
	exitList[exitIndex].visible = true;
	exitList[exitIndex].y = exitList[exitIndex].y + exitList[exitIndex].offset; 
	
	playerList[playerIndex].removeEventListener("pressmove", playerPressDown);
	playerList[playerIndex].removeEventListener("pressup", playerPressUp);
	playerList[playerIndex].active = false;
	
	showExitScore();
	closeGame();
	doPlayerFinalOut(playerIndex);
					
	var exit00 = createjs.Tween.get(exitList[exitIndex])
		.wait(exitList[exitIndex].pause)
		.call(playerFinalExit)
		.to({alpha:1, y:finalExitY }, exitList[exitIndex].time, exitTweenIn)
		.call(socialFinal);
		
		if(loadQueueLive == true){ // if live, http game....
			enterChoice();
			if(logEngagement){ logEngagement("game-end") };
			//$.get(document.URL.split('?')[0] + '/scratch');
		}
		
}

function playerFinalExit(){
	var thisAlpha = playerList[playerIndex].alpha;
	
	if(thisAlpha > 0.5){
		closeGame();
	}
	
	doAutoGateway();
}

function showExitScore(){
	scoreList[1].visible = true;
	scoreList[1].alpha = 1; //0;
	scoreContainerList[1].alpha = 0;
	
			var scoreY = scoreContainerList[1].y;
			scoreList[1].visible = true;
			scoreContainerList[1].y += exitList[exitIndex].offset;
	
			var tween00 = createjs.Tween.get(scoreContainerList[1])
							.wait(exitList[exitIndex].pause)
							.to({alpha:1, y:scoreY}, exitList[exitIndex].time, exitTweenIn);
	
}

function closeGame(){
	
	var player00 = createjs.Tween.get(playerList[playerIndex]).to({alpha:0}, 500, createjs.Ease.sineOut);
	
}

/* :::::::::: [ checkGameStatus FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ checkGameStatus FUNCTIONS END ] ::::::::::: */
		 
		 function addUpshot(pctIndex){
			var img = queue.getResult(manifest[pctIndex].src);
			var bmp = new createjs.Bitmap(img);
			 	bmp.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
				bmp.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
				bmp.x = manifest[pctIndex].x;
				bmp.y = manifest[pctIndex].y;
			 	bmp.width = manifest[pctIndex].width;
				bmp.height = manifest[pctIndex].height;
				bmp.alpha = 1;
				bmp.index = upshotList.length; //pctIndex;
				stage.addChild(bmp);
				upshotList.push(bmp);
			}
		 
		 function addSkin(pctIndex){
				var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
					bmp.alpha = 1;
					bmp.index = skinList.length; //pctIndex;
					stage.addChild(bmp);
					skinList.push(bmp);
			}

		 function addOffPlayer(pctIndex){
			 
			 var thisIndex = offPlayerList.length;
			 
			 	var bmpMask = new createjs.Shape();
					bmpMask.graphics.drawRect(0, 0, manifest[pctIndex].width, manifest[pctIndex].height);
					bmpMask.regX = (manifest[pctIndex].width * 0.5);
					bmpMask.regY = (manifest[pctIndex].height * 0.5);
			 
				var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
			 		bmp.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
			 		bmp.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
					bmp.x = 0;//manifest[pctIndex].x;
					bmp.y = 0;// manifest[pctIndex].y;
					bmp.alpha = 1;
			 		bmp.rotation = 0;
			 		bmp.visible = true;
			 		bmp.mask = bmpMask;
					bmp.index = thisIndex; //pctIndex;
			 
			 	var container = new createjs.Container();
					container.x = manifest[pctIndex].x;
					container.y = manifest[pctIndex].y;
					container.width = manifest[pctIndex].width;
					container.height = manifest[pctIndex].height;
					container.alpha = 1;
					container.index = thisIndex;
					container.rotation = 0;
					container.cursor = "pointer";
			 		container.visible = true;
			 
					stage.addChild(container);
					container.addChild(bmp, bmpMask );
			 
			 		offPlayerBmpList.push(bmp);
			 		offPlayerList.push(container);
			 
			 		trackOffDisplay = manifest[pctIndex].track;
			 
			}


/* :::::::::: [ MOTION FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ MOTION FUNCTIONS START ] ::::::::::: */

		 function addBkgMotion(pctIndex){
			
			 bkgPickList.push(bkgList.length);
			 
			var img = queue.getResult(manifest[pctIndex].src);
			var bmp = new createjs.Bitmap(img);
			 	bmp.regX = Math.round( manifest[pctIndex].width * 0.5 ) ;
				bmp.regY = Math.round( manifest[pctIndex].height * 0.5 ) ;
				bmp.x = manifest[pctIndex].x;
				bmp.y = manifest[pctIndex].y;
			 	bmp.width = manifest[pctIndex].width;
				bmp.height = manifest[pctIndex].height;
				bmp.alpha = 0;
			 	bmp.visible = false;
				bmp.index = bkgList.length; //pctIndex;
				stage.addChild(bmp);
				bkgList.push(bmp);
			}


function doBkgMotion(){

	var randomPick = Math.floor( Math.random() * bkgPickList.length );
	var randomIndex = bkgPickList[randomPick];
	var continueLoop = true;
	
	if(exitFired == true && bkgLoopForever == false){
		continueLoop = false;
	}
		
	var thisIndex = randomIndex; //Math.floor(bkgList.length * Math.random() );
	bkgPickList.splice(randomPick, 1);
	
	bkgList[thisIndex].alpha = bkgAlphaIn ;
	bkgList[thisIndex].visible = true;
	bkgList[thisIndex].x = bkgInX;
	bkgList[thisIndex].y = bkgInY;
	bkgList[thisIndex].scaleX = bkgScaleIn;
	bkgList[thisIndex].scaleY = bkgScaleIn;
	var spinPlusMinus = Math.random() < 0.5 ? -1 : 1;
	if(bkgRandomAngles == false){spinPlusMinus = 1};
	bkgList[thisIndex].rotation = (bkgSpin  + (Math.random() * bkgSpinOffset)) * spinPlusMinus ;
	
	if(continueLoop == true){
		
		var bkg00 = createjs.Tween.get(bkgList[thisIndex])
					.wait(bkgNextTime)		
					.call(doBkgMotion)
					.to({alpha:bkgAlphaOut, x:bkgOutX, y:bkgOutY, scaleX:bkgScaleOut, scaleY:bkgScaleOut, rotation:0 }, bkgTime, bkgTween)
					.call(closeBkgTween, [thisIndex], this);
		
	} // if continueLoop

}

function closeBkgTween(index){
	bkgList[index].visible = false;
	bkgList[index].alpha = bkgAlphaIn;
	bkgPickList.push(index);
	
}

/* :::::::::: [ MOTION FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ MOTION FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ POPPER FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ POPPER FUNCTIONS START ] ::::::::::: */

		function addPop(pctIndex){
				
				var img = queue.getResult(manifest[pctIndex].src);
				var bmp = new createjs.Bitmap(img);
					bmp.regX = Math.round(manifest[pctIndex].width * 0.5);
					bmp.regY = Math.round(manifest[pctIndex].height * 0.5);
					bmp.x = manifest[pctIndex].x;
					bmp.y = manifest[pctIndex].y;
					bmp.alpha = 0;
					bmp.scaleX = 0.2;
					bmp.scaleY = 0.2;
					bmp.time = manifest[pctIndex].time;
					bmp.rotation = manifest[pctIndex].rotation;
					bmp.index = popList.length; //pctIndex;
					stage.addChild(bmp);
					popList.push(bmp);
			}

		 function showPop(index){
			
			var directionIndex  = Math.random() < 0.5 ? -1 : 1;
			var thisSpin = popList[0].rotation * directionIndex;
			 
			choiceList.push(iconList[index].slot);
			
			popList[0].x = iconList[index].x;
			popList[0].y = iconList[index].y;
			popList[0].scaleX = popList[0].scaleY = 0.1;
			popList[0].alpha = 1;
			popList[0].rotation = 0;
			 
			switch(liveHitClass) {
				case "icon" :
					addSparkles(0, iconList[liveHitIndex].x, iconList[liveHitIndex].y);
					break;
				case "player":
					popList[0].x = playerList[playerIndex].x;
					popList[0].y = playerList[playerIndex].y;
					addSparkles(0, playerList[playerIndex].x, playerList[playerIndex].y);
					break;
				case "icon-player":
					popList[0].x = playerList[playerIndex].x;
					popList[0].y = playerList[playerIndex].y;
					addSparkles(0, playerList[playerIndex].x, playerList[playerIndex].y);
					break;
				default:
					addSparkles(0, iconList[liveHitIndex].x, iconList[liveHitIndex].y);
				} // end liveHitClass switch
			 
			 var pop00 = createjs.Tween.get(popList[0])
			 				.to({alpha:0, scaleX:1, scaleY:1, rotation:thisSpin}, popList[0].time, createjs.Ease.sineOut);
			 
		 }

/* :::::::::: [ POPPER FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ POPPER FUNCTIONS END ] ::::::::::: */

/* :::::::::: [ ADD MARKER START ] :::::::::: */
/* :::::::::: [ ADD MARKER START ] :::::::::: */
/* :::::::::: [ ADD MARKER START ] :::::::::: */

		function addMarker(pctIndex){
			
			var thisLength = (markerCount); 
			var thisOffset = markerspecs.offset;
			trackMarker = manifest[pctIndex].track;
			
			for (q = 0; q < thisLength; q++) { 
				
				var thisIndex = q; // markerBmpList.length;

				var markerMask = new createjs.Shape();
						markerMask.graphics.drawRect(0, 0, thisOffset, thisOffset);
						markerMask.regX = (thisOffset * 0.5);
						markerMask.regY = (thisOffset * 0.5);
						markerMask.x = 0; // manifest[pctIndex].x;
						markerMask.y = 0; // manifest[pctIndex].y;

				 var img = queue.getResult(manifest[pctIndex].src);
				 var bmp = new createjs.Bitmap(img);
						bmp.regX = Math.round(manifest[pctIndex].width * 0.5 );
						bmp.regY = Math.round(manifest[pctIndex].height * 0.5 );
						bmp.x = 0;
						bmp.y = thisOffset * q * -1;
						bmp.width = manifest[pctIndex].width;
						bmp.height = manifest[pctIndex].height;
						bmp.offset = thisOffset;
						bmp.moved = false;
						bmp.score = 0;
						bmp.alpha = 1; //markerspecs.introalpha;
						bmp.complete = false;
						bmp.homex = 0;
						bmp.index = thisIndex; //pctIndex;
						bmp.mask = markerMask;
						markerBmpList.push(bmp);

					var container = new createjs.Container();
						container.x = markerspecs.markerx[thisIndex];
						container.y = markerspecs.markery[thisIndex];
						container.z = markerspecs.markerz[thisIndex];
						container.alpha = markerspecs.introalpha;
						container.scaleX = 1;
						container.scaleY = 1;
						container.rotation = 0;
						stage.addChild(container);
						container.addChild(bmp, markerMask  );
						markerContainerList.push(container); 
								
			} // end loop
			
		} // end addMarker

function tweenMarker(value){
	var thisValue = value;
	var thisPause = 0;
		
	if(markerHasRightWrong == true && markerTargetScore < 1){
		thisValue = 1;
	}
	
	//if(markerBmpList[markerIndex] && markerBmpList[markerIndex].complete == false){
	if(markerBmpList[markerIndex] && markerBmpList[markerIndex].complete == false && iconList[markerIndex].score > markerNegativeFloor){
		markerBmpList[markerIndex].complete = true;
		switch(thisValue) {
			case 0:
				markerBmpList[markerIndex].x = markerBmpList[markerIndex].x; // DON'T MOVE MASKED BMP
				break;
			case 1:
				if(markerHasRightWrong == true){
					markerBmpList[markerIndex].x -= markerBmpList[markerIndex].offset; // MOVE MASKED BMP 
					markerBmpList[markerIndex].moved = true;
				} else {
					markerBmpList[markerIndex].x = markerBmpList[markerIndex].x; // DON'T MOVE MASKED BMP
				} // end markerHasRightWrong if
				break;
			default:
				thisValue = thisValue;
		} // end switch


		var targetX = markerContainerList[markerIndex].x;
		var targetY = markerContainerList[markerIndex].y;
		markerContainerList[markerIndex].x = markerContainerList[markerIndex].x + markerOffsetX;
		markerContainerList[markerIndex].y = markerContainerList[markerIndex].y + markerOffsetY;
		markerContainerList[markerIndex].scaleX = markerScaleInX;
		markerContainerList[markerIndex].scaleY = markerScaleInY;
		markerContainerList[markerIndex].alpha = markerInAlpha;
		markerContainerList[markerIndex].rotation = markerRotation;
		
		var markerIn00 = createjs.Tween.get(markerContainerList[markerIndex])
									.wait(thisPause)
									.to({x:targetX, y:targetY, scaleX:1, scaleY:1, alpha:1, rotation:0}, markerTime, markerTween);
		
	} // end if .complete
	
} // end tweenMarker() Function

function doKillCheck(){
		if(killPositive == true && iconList[markerIndex].score > 0 ){
			// kill icon if score higher than 0
			iconList[markerIndex].killed = true;
		}
		
		if(killNegative == true && iconList[markerIndex].score < killCeiling ){
			// kill icon if score less than killCeiling
			iconList[markerIndex].killed = true;
		}
}

/* :::::::::: [ ADD MARKER END ] :::::::::: */
/* :::::::::: [ ADD MARKER END ] :::::::::: */
/* :::::::::: [ ADD MARKER END ] :::::::::: */


/* ::::::::::: [ AUTOGATEWAY CONTROLS START ] :::::::::: */
/* ::::::::::: [ AUTOGATEWAY CONTROLS START ] :::::::::: */

function doAutoGateway(){
	if(hasAutoGateway == true){
		
		autoGateIndex = exitIndex;
		var thisTime = autoGateTimeList[autoGateIndex];
		
		switch(thisTime) {
			case 0:
				hasAutoGateway = true;
				//if(exitSparks){ exitSparks = false}; // turn off sparks
				exitList[autoGateIndex].visible = false; // hide exit button
				scoreList[1].visible = false; // turn off centered score
				setTimeout(doGatewayTimeOut, thisTime);
				break;
			case -1:
				hasAutoGateway = false;
				break;
			default:
				hasAutoGateway = true;
				setTimeout(doGatewayTimeOut, thisTime);
		} // end thisTime switch
		
	} // end hasAutoGateway if
}

function doGatewayTimeOut(){

	if(linkTo != "location"){
		// REMOVE EXIT PNG CLICK IF SECURE EXIT ( PREVENTS DOUBLE SUBMISSION)
		exitList[autoGateIndex].removeAllEventListeners();
	}
	
	if(exitlinks[0].linkset.length > 1){
				linkTo = exitlinks[0].linkset[autoGateIndex]; // use index.htm linkto
			} else{
				linkTo = exitList[autoGateIndex].linkto;  // use content.js linkto
			}
			
			if(loadQueueLive == true){ // new window for http games...
					switch(linkTo) {
					case "open":
						linkWindow = window.open('', '_blank', windowTools);
						linkWindow.document.body.style.backgroundColor = "#000000";
						break;
					case "banner-open":
						linkWindow = window.open('', '_blank', windowTools);
						linkWindow.document.body.style.backgroundColor = "#000000";
						break;
					default:
						linkTo = linkTo;
					} // end switch
			} // end if loadQueue
	
			if(exitlinks[0].gatewaypath != "none"){
				exitAjax();
			} else {
				exitDemo();
			} // end gateway if/else
}

function exitDemo(){
	// REPLACES exitWin() & exitLoss
	var exitDefaultList = [
		exitlinks[0].default0, exitlinks[0].default1, exitlinks[0].default2, exitlinks[0].default3, 
		exitlinks[0].default4, exitlinks[0].default5, exitlinks[0].default6, exitlinks[0].default7, 
		exitlinks[0].default8, exitlinks[0].default9, exitlinks[0].default10, 
	];
	
	if(exitlinks[0].gatewaypath == "none"){
		window.location.replace(exitDefaultList[autoGateIndex]);
	}
	
}

/* ::::::::::: [ AUTOGATEWAY CONTROLS END ] :::::::::: */
/* ::::::::::: [ AUTOGATEWAY CONTROLS END ] :::::::::: */
		
		/* :::::::::: [ CONTROLS END ] :::::::::: */
		
/* :::::::::: [ UTILITY FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ UTILITY FUNCTIONS START ] ::::::::::: */
/* :::::::::: [ UTILITY FUNCTIONS START ] ::::::::::: */
		
		function addGameClass(){
			 
			switch(gameclass) {
			case "live":
				gameclass = gameclass;
				break;
			case "presentation":
				gameclass = gameclass;
				break;
			default:
				var ucGameClass = gameclass.toUpperCase();
				var txt = new createjs.Text(ucGameClass, "21px Arial", "#FFFFFF");
				txt.x = 320;
				txt.y = 445;
				txt.alpha = 0.6;
				txt.textAlign = "center";
				txt.shadow = new createjs.Shadow("#000000", 2, 2, 1);
				stage.addChild(txt);
			} //end switch
			 
		 }
		
		function addForm(){

			/*var thisForm = 
			"<form class='collapse' id='choiceForm'><input name='upshotpath' id='upshotpath' class='form-control' value=''></form>";
			$('body').append(thisForm);
			*/
			 
			 // CHANGE LOADQEUE BOOLEAN IF LIVE GAME
			var thisUrl = window.location.href;
			 var isFile = thisUrl.match( /file:/ );
			 if(isFile == "file:"){
				 loadQueueLive = false;
			 }
			 /* */
			 
		}

function setSpecs(){
	
	var thisExitClass = exitlinks[0].gateclass;
	var exitSrcCount = -1;
	var thisSpacer = "spacer1x1canvas.png";
	
	if(exitlinks[0].autogateway){ // format arrays for autoGateway
		specAutoGateway();
	   } // end autogateway if
	
	for (i = 0; i < manifest.length; i++) {
				if(manifest[i].class == "exit"){ // FILTER EXIT GRAPHICS		
					exitSrcCount += 1;

					switch(thisExitClass) {
						case "winlevel":
							if(exitSrcCount != winlevel){
								manifest[i].src = thisSpacer;
							}
							break;
						case "score":
							if(exitSrcCount > 1){
								manifest[i].src = thisSpacer;
							}
							break;
						default:
							thisExitClass = thisExitClass;
					} // end thisExitClass switch
					
					if(hasAutoGateway == true && autoGateTimeList[exitSrcCount] == 0 ){
							manifest[i].src = "spacer1x1canvas.png";
						}
					
				} // exit if
			} // end manifest for loop

		// OPEN SCORE MIN/MAX IF NOT A SCORE GAME
	
		switch(thisExitClass) {
			case "multiexit":
					scoreMin = 0;
					scoreMax = 10;
				break;
			case "winlevel":
					scoreMin = 0;
					scoreMax = 99;
				break;
			case "score":
					scoreMin = scorespecs.scoremin;
					scoreMax = scorespecs.scoremax;
				break;
			default:
				exitlinks[0].gateclass = exitlinks[0].gateclass;
		} // end gateclass switch
	
		// linkset if....		
		if(exitlinks[0].linkset[0] == "none"){
			
			exitlinks[0].linkset = []; // reset index page array
			
			for (i = 0; i < manifest.length; i++) {
					if(manifest[i].class == "exit"){
						exitlinks[0].linkset.push(manifest[i].linkto); // populate array
					} // end exit if
			} // end manifest for
			
			if(pageid == "preview"){ // set this for preview.html
				var thisLinkSet = ["replace","replace","replace","replace","replace","replace","replace","replace","replace","replace","replace",];
				exitlinks[0].linkset = thisLinkSet ;
			}
		} // end linkset if
	
		if(roundMax > 1){
			hasRounds =  true;
			scoreMax = roundScoreMaxList[roundIndex];
			scoreMin = roundScoreMinList[roundIndex];
			timerMax = roundTimeList[roundIndex]
		}
	
	//FORM EXAMPLE = <form class='collapse' id='choiceForm'><input name='upshotpath' id='upshotpath' class='form-control' value=''></form>
	var thisForm = document.createElement('form');
			thisForm.className = "collapse"; // 
			thisForm.id = "choiceForm"
			thisForm.innerHTML = "<input name='upshotpath' id='upshotpath' class='form-control' value=''>"
			document.body.append(thisForm);
		
	
} // END setSpecs

/* ::::::::::: [ AUTOGATEWAY SPECS START ] ::::::::::: */
/* ::::::::::: [ AUTOGATEWAY SPECS START ] ::::::::::: */

function specAutoGateway(){
	var thisAutoList = exitlinks[0].autogateway.replace(/[^0-9,.-]/g, "").split(",");

	// POPULATE autoGatewayList FROM thisAutoList ....
	if( exitlinks[0].autogateway != "-1"){
			for (i = 0; i < thisAutoList.length; i++) { 
				var thisNumber = parseFloat( thisAutoList[i] );
				autoGatewayList.push(thisNumber);
			}
			hasAutoGateway = true;
	   } else {
		  autoGatewayList.push(-1) 
	   }

	// FILL IN BLANKS FOR 0-10 EXITS, WITH LAST NUMBER PROVIDED ....
	if(hasAutoGateway == true && thisAutoList.length < 11 ){
		// complete array for exits 0-10
		for (i = 0; i < 11; i++) { 
			var lastNumber = autoGatewayList.length - 1;
			if(i >= thisAutoList.length ){
				var newNumber = autoGatewayList[lastNumber];
				autoGatewayList.push(newNumber);
			}
		}
	}

	// GENERATATE TWEEN TIMES ....
	for (i = 0; i < autoGatewayList.length; i++) { 
		var thisTime = autoGatewayList[i] * 1000;
		if(thisTime > 1){
			autoGateTimeList.push(thisTime);
		} else {
			autoGateTimeList.push(autoGatewayList[i]);
		}
	}
}
/* ::::::::::: [ AUTOGATEWAY SPECS END ] ::::::::::: */
/* ::::::::::: [ AUTOGATEWAY SPECS END ] ::::::::::: */

	function getParameterToEnd(name, url) {
        if (!url) url = window.location.href;
        loc = url.lastIndexOf(name);
        if (loc < 0) return null;
        return url.slice(loc + name.length + 1, url.length);
    }

	 function exitAjax(){
			 			 
		 var thisGateClass = exitlinks[0].gateclass;	
		 var scoreString = scoreIndex.toString();
		 var thisResult = scoreIndex;
		 //if(thisGateClass == "score"){thisResult = scoreIndex};

		var exitspecs = {
			gameclass:exitlinks[0].gateclass, 
			picklist:[scoreString],
			score:scoreIndex,
			exit:scoreString,
			result:thisResult,
		}; 
		 
		 switch(thisGateClass) {
			case "score":
				exitspecs.score = exitIndex;
				 /*if(scoreIndex >= scoreMin){
					exitspecs.score = 1;
				} else{
					exitspecs.score = 0;
				}
				*/
				break;
			case "multiexit":
				if(scoreIndex < 11){
					exitspecs.score = scoreIndex;
				} else{
					exitspecs.score = 10;
				}
				break 
			default:
				thisGateClass = thisGateClass;
		}
		 		 
			$.ajax({
				type: "POST",
				url: exitlinks[0].gatewaypath,
				data: exitspecs, // USE IF CHOICE RESULT
				success: function (response){
						// STANDARD CATABOOM EXITS...
					if ("linkto" in response) { linkTo = response.linkto };	
					switch(linkTo) {
							case "replace":
								window.location.replace(response.url);
								break;
							case "location":
								window.location.href = response.url;
								break;
							case "history":
									var historySource = 1;
									if ("steps" in response) { 
										historySource = response.steps;
									} else {
										historySource = response.url;
									}
									var historySteps = Number( historySource.replace(/\D+/g, '') ) * -1;
									window.history.go(historySteps);
								break;
							case "topframe":
								window.top.location.href = response.url;
								break;
							case "open":
								linkWindow.location.href = response.url;
								break;
							case "banner-open":
								// BANNER CLICKTRACK EXITS...
								var clickTrackerURL = getParameterToEnd("click");
								// START CALCULATE URL (AND JUMP), ADD DOMAIN IF RELATIVE LINK
								if (clickTrackerURL) {
									if (response.url.startsWith("/")) {
										var thisLink = clickTrackerURL + window.location.href.split('/').slice(0, 3).join('/') + response.url;
										linkWindow.location.href = thisLink;
									} else {
										linkWindow.location.href = clickTrackerURL + response.url;
									}
								} else {
									linkWindow.location.href = response.url;
								}
								// END CALCULATE URL (AND JUMP)
								break;
							default:
								window.location.replace(response.url);
						} // end switch linkTo
				}, // end success
				error: function(response){
					var data = JSON.parse(response.responseText);
					if ("url" in data) {
						  window.location.replace(data.url);
					} else {  alert("Error: " + response.text); } //end if/else  // end error func
				}
			}); 
	 } // end exitAjax

/* ::::::::::: [ CHOICE FUNCTIONS START ] :::::::::::: */
/* ::::::::::: [ CHOICE FUNCTIONS START ] :::::::::::: */

		 function enterChoice(){
			 
			 var thisChoiceString = choiceList.toString();
			 $('#upshotpath').val(thisChoiceString);
			 
			 if(gameclass == "test" || gameclass == "live" ){
					//send the chosen item to server
					choiceAjax();
				}
		 }
		 
		 
		 function choiceAjax(){
				 
					$.ajax({
						type: "POST",
						url: exitlinks[0].choicepath,
						data: $('#choiceForm').serialize(),
						error: function(response){
							var data = JSON.parse(response.responseText);
							if ("url" in data) {
								  window.location.href = data.url;
							} else {  alert("Error: " + response.text); } //end if/else  // end error func
						}
					}); 
				 
		 } // end choiceAjax

/* ::::::::::: [ CHOICE FUNCTIONS END ] :::::::::::: */
/* ::::::::::: [ CHOICE FUNCTIONS END ] :::::::::::: */

		function socialFinal(){

			if(exitlinks[0].showsocial){ // if social header present....
				var showThis = exitlinks[0].showsocial;
				var socialShowList = showThis.split("|");

				if(socialShowList[winlevel] == "true"){
					$("#boomSocial").delay(1000).fadeIn();
				} // end  social if
			} // end livegame if
		} // end social final
		
/* :::::::::: [ UTILITY FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ UTILITY FUNCTIONS END ] ::::::::::: */
/* :::::::::: [ UTILITY FUNCTIONS END ] ::::::::::: */

        function handleTick(event) {
			// TRACK COLLISIONS
			switch(collisionClass) {
				case "active":
					if(playerList[playerIndex].active == true){ trackColllision() }; // track hits only on active
					break;
				case "passive":
					trackColllision(); // track hits anytime
					break;
				default:
					trackColllision(); // track hits anytime
			} // end collisionClass switch
			
			if(trackOffDisplay == true){ trackPlayerDisplay() }; // TRACK PLAYER ON/OFF
            stage.update();
        }
